{**********************************************************************
                Copyright (c) PilotLogic Software House

 Package pl_FFmpeg5
 This file is part of CodeTyphon Studio (https://www.pilotlogic.com/)

 ***** BEGIN LICENSE BLOCK *****
 * Version: LGPL-2.1 with link exception (Modified LGPL)
 *
 * The contents of this file are subject to the
 * GNU LIBRARY GENERAL PUBLIC LICENSE Version 2.1 (the "License")
 * with the following modification:
 *
 * As a special exception, the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your choice,
 * provided that you also meet, for each linked independent module, the terms
 * and conditions of the license of that module. An independent module is a
 * module which is not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library, but
 * you are not obligated to do so. If you do not wish to do so, delete this
 * exception statement from your version.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * ***** END LICENSE BLOCK *****

***********************************************************************}

Unit ffmpeg_types;

{$MODE objfpc}{$H+}

Interface

Type
   Bool = WordBool;
   float = Single;
   ppDouble = ^pDouble;

   size_t = NativeUInt;
   psize_t = ^size_t;
   ptrdiff_t = UInt32;
   uint32_t = Cardinal;
   unsigned = uint32_t;
   unsignedint = UInt32;
   UINT = unsigned;
   unsigned_int = UInt32;
   punsigned_int = ^unsigned_int;
   unsigned_long = Cardinal;

   unsignedchar = Byte;
   unsigned_char = unsignedchar;
   punsignedchar = PByte;
   punsigned_char = punsignedchar;

   Int = Integer;
   pint = ^Int;
   ppint = ^pint;

   int8_t = Int8;
   pint8_t = ^int8_t;

   uint8_t = Byte;
   puint8_t = PByte;
   ppuint8_t = ^puint8_t;
   PPByte = ppuint8_t;  
   PPPByte = ^PPByte;

   int16_t = int16;
   pint16_t = ^int16_t;
   uint16_t = UInt16;
   puint16_t = ^uint16_t;

   int32_t = Int32;
   pint32_t = ^int32_t;
   ppint32_t = ^pint32_t;

   int64_t = Int64;
   pint64_t = ^int64_t;
   uint64_t = UInt64;
   puint64_t = ^uint64_t;

   array_uint8_t = Array[0..0] Of uint8_t;
   parray_uint8_t = ^array_uint8_t;

   array_int = Array[0..0] Of Int;
   parray_int = ^array_int;

   array4_int = Array[0..3] Of Int;
   parray4_int = ^array4_int;

   array4_puint8_t = Array[0..3] Of puint8_t;
   parray4_puint8_t = ^array4_puint8_t;

   array4_ptrdiff_t = Array[0..3] Of ptrdiff_t;
   parray4_ptrdiff_t = ^array4_ptrdiff_t;

   time_t = LongInt;

   AnsiCharArray = Array[0..0] Of pAnsiChar;
   pAnsiCharArray = ^AnsiCharArray;

   _iobuf = Record
      _ptr: pAnsiChar;
      _cnt: Integer;
      _base: pAnsiChar;
      _flag: Integer;
      _file: Integer;
      _charbuf: Integer;
      _bufsiz: Integer;
      _tmpfname: pAnsiChar;
   End;

   PFile = ^TFile;
   TFile = _iobuf;

   pAVHWAccel = Pointer;
   ppAVCodecHWConfigInternal = Pointer;

Const
   max_unsigned = $FFFF;

Implementation

End.
