{**********************************************************************
                Copyright (c) PilotLogic Software House

 Package pl_FFmpeg5
 This file is part of CodeTyphon Studio (https://www.pilotlogic.com/)

 ***** BEGIN LICENSE BLOCK *****
 * Version: LGPL-2.1 with link exception (Modified LGPL)
 *
 * The contents of this file are subject to the
 * GNU LIBRARY GENERAL PUBLIC LICENSE Version 2.1 (the "License")
 * with the following modification:
 *
 * As a special exception, the copyright holders of this library give you
 * permission to link this library with independent modules to produce an
 * executable, regardless of the license terms of these independent modules,
 * and to copy and distribute the resulting executable under terms of your choice,
 * provided that you also meet, for each linked independent module, the terms
 * and conditions of the license of that module. An independent module is a
 * module which is not derived from or based on this library. If you modify this
 * library, you may extend this exception to your version of the library, but
 * you are not obligated to do so. If you do not wish to do so, delete this
 * exception statement from your version.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * ***** END LICENSE BLOCK *****

***********************************************************************}

Unit libswresample;

{$MODE objfpc}{$H+}

Interface

Uses
  ctypes,
  Classes, dynlibs,
  ffmpeg_types, libavutil, libavformat;

Const
{$IF defined(MSWINDOWS)}
   swresampleLibName = 'swresample-4.dll';
{$ELSEIF defined(LINUX)}
   swresampleLibName = 'libswresample.so.4';
{$ELSEIF defined(DARWIN)}
   swresampleLibName = 'libswresample.4.dylib';
{$ELSE}
   swresampleLibName = 'libswresample.so.4';
{$ENDIF}

Const
   SWR_FLAG_RESAMPLE = 1;

Type
   SwrDitherType = (
      SWR_DITHER_NONE = 0,
      SWR_DITHER_RECTANGULAR,
      SWR_DITHER_TRIANGULAR,
      SWR_DITHER_TRIANGULAR_HIGHPASS,
      SWR_DITHER_NS = 64,
      SWR_DITHER_NS_LIPSHITZ,
      SWR_DITHER_NS_F_WEIGHTED,
      SWR_DITHER_NS_MODIFIED_E_WEIGHTED,
      SWR_DITHER_NS_IMPROVED_E_WEIGHTED,
      SWR_DITHER_NS_SHIBATA,
      SWR_DITHER_NS_LOW_SHIBATA,
      SWR_DITHER_NS_HIGH_SHIBATA,
      SWR_DITHER_NB
      );

   SwrEngine = (
      SWR_ENGINE_SWR,
      SWR_ENGINE_SOXR,
      SWR_ENGINE_NB
      );

   SwrFilterType = (
      SWR_FILTER_TYPE_CUBIC,
      SWR_FILTER_TYPE_BLACKMAN_NUTTALL,
      SWR_FILTER_TYPE_KAISER
      );

Type
                   
   ppSwrContext = ^pSwrContext;
   pSwrContext = ^SwrContext;
   SwrContext = Record
   End;


   AVChannelLayout= AVFilterChannelLayouts;

  //...................................................

Type

   Tswr_get_class = function(): pAVClass; cdecl;
   Tswr_alloc = function(): pSwrContext; cdecl;
   Tswr_init = function(s: pSwrContext): int; cdecl;
   Tswr_is_initialized = function(s: pSwrContext): int; cdecl;
   Tswr_alloc_set_opts = function(s: pSwrContext; out_ch_layout: int64_t; out_sample_fmt: AVSampleFormat; out_sample_rate: int;
                                  in_ch_layout: int64_t; in_sample_fmt: AVSampleFormat; in_sample_rate: int;
                                  log_offset: int; log_ctx: Pointer): pSwrContext; cdecl;
   Tswr_free = Procedure(Var s: pSwrContext); cdecl;
   Tswr_close = Procedure(s: pSwrContext); cdecl;
   Tswr_convert = function(s: pSwrContext; _out: ppuint8_t; out_count: int; Const _in: ppuint8_t; in_count: int): int; cdecl;
   Tswr_next_pts = function(s: pSwrContext; pts: int64_t): int64_t; cdecl;
   Tswr_set_compensation = function(s: pSwrContext; sample_delta: int; compensation_distance: int): int; cdecl;
   Tswr_set_channel_mapping = function(s: pSwrContext; Const channel_map: pint): int; cdecl;
   Tswr_build_matrix = function(in_layout: uint64_t; out_layout: uint64_t; center_mix_level: double; surround_mix_level: double;
                                lfe_mix_level: double; rematrix_maxval: double; rematrix_volume: double; Var matrix: double; stride: int;
                                matrix_encoding: AVMatrixEncoding; log_ctx: Pointer): int; cdecl;
   Tswr_set_matrix = function(s: pSwrContext; Const matrix: pdouble; stride: int): int; cdecl;
   Tswr_drop_output = function(s: pSwrContext; count: int): int; cdecl;
   Tswr_inject_silence = function(s: pSwrContext; count: int): int; cdecl;
   Tswr_get_delay = function(s: pSwrContext; base: int64_t): int64_t; cdecl;
   Tswr_get_out_samples = function(s: pSwrContext; in_samples: int): int; cdecl;
   Tswresample_version = function(): unsigned; cdecl;
   Tswresample_configuration = function(): pAnsiChar; cdecl;
   Tswresample_license = function(): pAnsiChar; cdecl;
   Tswr_convert_frame = function(swr: pSwrContext; output: pAVFrame; Const input: pAVFrame): int; cdecl;
   Tswr_config_frame = function(swr: pSwrContext; Const _out: pAVFrame; Const _in: pAVFrame): int; cdecl;
   Tswr_alloc_set_opts2 = Function(var ps:PSwrContext; var out_ch_layout:AVChannelLayout; out_sample_fmt:AVSampleFormat; out_sample_rate:longint; var in_ch_layout:AVChannelLayout;
                                   in_sample_fmt:AVSampleFormat; in_sample_rate:longint; log_offset:longint; log_ctx:pointer):longint;cdecl;
   Tswr_build_matrix2 = Function(var in_layout:AVChannelLayout; var out_layout:AVChannelLayout; center_mix_level:double; surround_mix_level:double; lfe_mix_level:double;
                                 maxval:double; rematrix_volume:double; var matrix:double; stride:ptrdiff_t; matrix_encoding:AVMatrixEncoding;log_context:pointer):longint;cdecl;

  //....................................................

Var

   swr_get_class : Tswr_get_class = Nil;
   swr_alloc : Tswr_alloc = Nil;
   swr_init : Tswr_init = Nil;
   swr_is_initialized : Tswr_is_initialized = Nil;
   swr_alloc_set_opts : Tswr_alloc_set_opts = Nil;
   swr_free : Tswr_free = Nil;
   swr_close : Tswr_close = Nil;
   swr_convert : Tswr_convert = Nil;
   swr_next_pts : Tswr_next_pts = Nil;
   swr_set_compensation : Tswr_set_compensation  = Nil;
   swr_set_channel_mapping : Tswr_set_channel_mapping = Nil;
   swr_build_matrix : Tswr_build_matrix = Nil;
   swr_set_matrix : Tswr_set_matrix = Nil;
   swr_drop_output : Tswr_drop_output = Nil;
   swr_inject_silence : Tswr_inject_silence = Nil;
   swr_get_delay : Tswr_get_delay = Nil;
   swr_get_out_samples : Tswr_get_out_samples = Nil;
   swresample_version : Tswresample_version = Nil;
   swresample_configuration : Tswresample_configuration = Nil;
   swresample_license : Tswresample_license = Nil;
   swr_convert_frame : Tswr_convert_frame = Nil;
   swr_config_frame : Tswr_config_frame = Nil; 
   swr_alloc_set_opts2 : Tswr_alloc_set_opts2 = Nil;  
   swr_build_matrix2 : Tswr_build_matrix2 = Nil;

//.........................

Function  libswresample_Load(Const aLibName: String = swresampleLibName): Boolean;
Procedure libswresample_Free;
Function  libswresample_IsLoaded: boolean;

//==============================================================
//==============================================================
implementation

Const
   InvalidLibHandle = 0;

var
  swresample_Handle: TLibHandle;

function libswresample_IsLoaded: boolean;
begin
  Result := (swresample_Handle <> InvalidLibHandle);
end;

Procedure libswresample_Free;
begin
  if libswresample_IsLoaded then
  begin
    DynLibs.UnloadLibrary(swresample_Handle);
    swresample_Handle := InvalidLibHandle;
  end;
end;

function libswresample_Load(Const aLibName: String = swresampleLibName): Boolean;
//.............................
   Function _GetProcAddress(Const aProcName: String): {$IFDEF cpui8086}FarPointer{$ELSE}Pointer{$ENDIF};
   Begin
      result := Nil;
      If aProcName = '' Then
         exit;

      result := dynlibs.GetProcedureAddress(swresample_Handle, AnsiString(aProcName));
   End;
   //.....................................
var
  thelib: string;

{$IF DEFINED(UNIX) and (NOT DEFINED(DARWIN))}
  ssl:Integer;
  ssp:Integer;
{$ENDIF}
begin
  Result := False;

  if swresample_Handle <> InvalidLibHandle then Exit(True);

  if aLibName = '' then
     thelib := swresampleLibName else
     thelib := aLibName;

  swresample_Handle := dynlibs.LoadLibrary(thelib);

   //.....................................
   // On UNIX If Library NOT load, try to load .so file
  {$IF DEFINED(UNIX) and (NOT DEFINED(DARWIN))}
   If swresample_Handle = 0 Then
   Begin
      ssl := length(thelib);
      ssp := Pos('.so.', thelib);
      If ssp > 0 Then
         delete(thelib, ssp, ssl - ssp + 1);

      swresample_Handle := dynlibs.LoadLibrary(thelib + '.so');
   End;
  {$ENDIF}

    if swresample_Handle = InvalidLibHandle then Exit(False);

    //.........................................

    Pointer(swr_get_class) := _GetProcAddress('swr_get_class');
    Pointer(swr_alloc) := _GetProcAddress('swr_alloc');
    Pointer(swr_init) := _GetProcAddress('swr_init');
    Pointer(swr_is_initialized) := _GetProcAddress('swr_is_initialized');
    Pointer(swr_alloc_set_opts) := _GetProcAddress('swr_alloc_set_opts');
    Pointer(swr_free) := _GetProcAddress('swr_free');
    Pointer(swr_close) := _GetProcAddress('swr_close');
    Pointer(swr_convert) := _GetProcAddress('swr_convert');
    Pointer(swr_next_pts) := _GetProcAddress('swr_next_pts');
    Pointer(swr_set_compensation) := _GetProcAddress('swr_set_compensation');
    Pointer(swr_set_channel_mapping) := _GetProcAddress('swr_set_channel_mapping');
    Pointer(swr_build_matrix) := _GetProcAddress('swr_build_matrix');
    Pointer(swr_set_matrix) := _GetProcAddress('swr_set_matrix');
    Pointer(swr_drop_output) := _GetProcAddress('swr_drop_output');
    Pointer(swr_inject_silence) := _GetProcAddress('swr_inject_silence');
    Pointer(swr_get_delay) := _GetProcAddress('swr_get_delay');
    Pointer(swr_get_out_samples) := _GetProcAddress('swr_get_out_samples');
    Pointer(swresample_version) := _GetProcAddress('swresample_version');
    Pointer(swresample_configuration) := _GetProcAddress('swresample_configuration');
    Pointer(swresample_license) := _GetProcAddress('swresample_license');
    Pointer(swr_convert_frame) := _GetProcAddress('swr_convert_frame');
    Pointer(swr_config_frame) := _GetProcAddress('swr_config_frame'); 
    Pointer(swr_alloc_set_opts2) := _GetProcAddress('swr_alloc_set_opts2');  
    Pointer(swr_build_matrix2) := _GetProcAddress('swr_build_matrix2');

    //.........................................

    Result := True;

end;

end.
